Public Class DataAccess
    Private objCmd As OleDb.OleDbCommand
    Private strConn As String = "Provider=Microsoft.Jet.OLEDB.4.0;Password="""";User ID=Admin;Data Source=C:\Southwater.mdb;"
    Private objDr As OleDb.OleDbDataReader

    Public Function PopulateComboBox(ByVal tableColumn As String, ByVal table As String) As Object

        Dim objItem As ArrayList = New ArrayList

        Dim index As Integer = 1
        Dim strValue As String

        OpenConnection()
        objCmd.CommandText = "Select " & tableColumn & " From " & table
        objDr = objCmd.ExecuteReader(CommandBehavior.CloseConnection)

        Do While objDr.Read()
  
            strValue = objDr.Item(tableColumn)
            objItem.Add(strValue)
             
        Loop
        objDr.Close()
        CloseConnection()
        Return objItem

    End Function

    Public Function SelectSuppliers(ByVal supplierId As String) As Object

        Dim objItem(8) As String
        Dim index As Integer = 1

        OpenConnection()
        objCmd.CommandText = "Select * From Suppliers Where SupplierID = " & supplierId
        objDr = objCmd.ExecuteReader(CommandBehavior.CloseConnection)

        Do While objDr.Read()

            objItem(0) = objDr.Item("SupplierID")
            objItem(1) = objDr.Item("CompanyName")
            objItem(2) = objDr.Item("Address")
            objItem(3) = objDr.Item("City")
            objItem(4) = objDr.Item("State")
            objItem(5) = objDr.Item("PostalCode")
            objItem(6) = objDr.Item("Country")
            objItem(7) = objDr.Item("Phone")


        Loop
        objDr.Close()
        CloseConnection()
        Return objItem

    End Function



    Public Function AddSupplier(ByVal state As Integer, ByVal country As Integer, ByVal companyName As String, ByVal Address As String, ByVal City As String, ByVal Postal As String, ByVal Phone As String) As Boolean
        Try
            OpenConnection()
            objCmd.CommandText = "INSERT INTO Suppliers(CompanyName, Address, City, State, PostalCode, Country, Phone) values( '" & companyName & "','" & Address & "','" & City & "','" & state & "','" & Postal & "','" & country & "', '" & Phone & "')"
            objDr = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
            objDr.Close()
            CloseConnection()
            Return True

        Catch ex As Exception

            MessageBox.Show(ex.ToString)

        End Try

    End Function

    Public Function UpdateSupplier(ByVal supplierId As Integer, ByVal state As Integer, ByVal country As Integer, ByVal companyName As String, ByVal Address As String, ByVal City As String, ByVal Postal As String, ByVal Phone As String) As Boolean
      
        ' Try
        OpenConnection()
        objCmd.CommandText = "UPDATE Suppliers SET CompanyName = '" & companyName & "', Address = '" & Address & "' , City = '" & City & "' , State = " & state & ", PostalCode = '" & Postal & "', Country = " & country & " , Phone = '" & Phone & "' WHERE SupplierId = " & supplierId & ""
        'objCmd.CommandText = "DELETE FROM Suppliers WHERE SupplierId = " & supplierId & ""



        objDr = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
        objDr.Close()
        CloseConnection()
        Return True

        ' Catch ex As Exception

        '  MessageBox.Show(ex.ToString)

        '   End Try

    End Function
    Public Function DeleteSupplier(ByVal supplierId As Integer) As Boolean

        ' Try
        OpenConnection()
        objCmd.CommandText = "DELETE FROM Suppliers WHERE SupplierId = " & supplierId & ""



        objDr = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
        objDr.Close()
        CloseConnection()
        Return True

        ' Catch ex As Exception

        '  MessageBox.Show(ex.ToString)

        '   End Try

    End Function


    Private Function OpenConnection() As Boolean
        objCmd = New OleDb.OleDbCommand()
        objCmd.Connection = New OleDb.OleDbConnection(strConn)
        objCmd.Connection.Open()
        Return True
    End Function

    Private Function CloseConnection() As Boolean
        objCmd.Connection.Close()
    End Function

End Class


 



