Public Class Southwater

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAddNew.Click
     
        clear()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadComboBoxes()
        LoadSuppliers()

    End Sub
    Private Sub clear()
        lblSupplierIdOut.Text = ""
        cbxState.SelectedIndex = 0
        cbxCountry.SelectedIndex = 0
        tbxCompanyName.Clear()
        tbxAddress.Clear()
        tbxCity.Clear()
        tbxPostal.Clear()
        tbxPhone.Clear()
    End Sub
    Private Sub LoadComboBoxes()

        Dim objDataAccess As DataAccess = New DataAccess
        Dim strValue As String
        Dim index As Integer

        Dim aryState As ArrayList = objDataAccess.PopulateComboBox("StateName", "States")
        Dim aryCountry As ArrayList = objDataAccess.PopulateComboBox("CountryName", "Countries")


        cbxState.Items.Clear()
        cbxCountry.Items.Clear()

        For index = 0 To aryState.Count - 1
            strValue = aryState(index)
            cbxState.Items.Add(strValue)
        Next index

        For index = 0 To aryCountry.Count - 1
            strValue = aryCountry(index)
            cbxCountry.Items.Add(strValue)
        Next index

   

        cbxState.SelectedIndex = 0
        cbxCountry.SelectedIndex = 0
        


    End Sub



    Private Sub cbxState_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxState.SelectedIndexChanged

    End Sub

    Private Sub butSaveNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSaveNew.Click

        If lblSupplierIdOut.Text.Length > 0 Then
            MessageBox.Show("You cannot ovewrite an existing record!", _
                               "Save New", MessageBoxButtons.OK, _
                               MessageBoxIcon.Exclamation)

            Exit Sub
        End If

        If tbxCompanyName.Text.Length < 1 Then
            MessageBox.Show("Please Eneter A Company Name!", _
                               "Save New", MessageBoxButtons.OK, _
                               MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        If tbxCity.Text.Length < 1 Then
            MessageBox.Show("Please Eneter A City!", _
                                 "Save New", MessageBoxButtons.OK, _
                                 MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim strState As String
        Dim strCountry As String
        Dim strCompanyName As String
        Dim strAddress As String
        Dim strCity As String
        Dim strPostal As String
        Dim strPhone As String

        strState = cbxState.SelectedIndex
        strCountry = cbxCountry.SelectedIndex
        strCompanyName = tbxCompanyName.Text
        strAddress = tbxAddress.Text
        strCity = tbxCity.Text
        strPostal = tbxPostal.Text
        strPhone = tbxPhone.Text

        Dim objDataAccess As DataAccess = New DataAccess


        objDataAccess.AddSupplier(Convert.ToInt32(strState), Convert.ToInt32(strCountry), strCompanyName, strAddress, strCity, strPostal, strPhone)
        LoadSuppliers()

    End Sub

  

    Private Sub LoadSuppliers()
        Dim objDataAccess As DataAccess = New DataAccess
        Dim Value1 As String
        Dim Value2 As String
        Dim index As Integer



        Dim arySupplieName As ArrayList = objDataAccess.PopulateComboBox("CompanyName", "Suppliers")
        Dim arySupplierId As ArrayList = objDataAccess.PopulateComboBox("SupplierID", "Suppliers")


        lbxSuppliers.Items.Clear()

        For index = 0 To arySupplieName.Count - 1

            Value1 = arySupplieName(index)
            Value2 = arySupplierId(index)

            lbxSuppliers.Items.Add(Value2 & "    -   " & Value1)

        Next index




    End Sub

    Private Sub lbxSuppliers_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lbxSuppliers.KeyDown

    End Sub

 

    Private Sub lbxSuppliers_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lbxSuppliers.MouseClick
      
      

    End Sub


    Private Sub lbxSuppliers_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbxSuppliers.SelectedIndexChanged
        indexMove()
    End Sub

    Private Sub indexMove()
        Dim objDataAccess As DataAccess = New DataAccess
        Dim value As String = lbxSuppliers.SelectedItem
        If value.Length < 0 Then
            Exit Sub
        End If
        Dim test As Array = objDataAccess.SelectSuppliers(value.Substring(0, 5))



        lblSupplierIdOut.Text = test(0)
        tbxCompanyName.Text = test(1)
        tbxAddress.Text = test(2)
        tbxCity.Text = test(3)

        If test(4) = 0 Then
            cbxState.SelectedIndex = 59
        Else

            cbxState.SelectedIndex = test(4)
            Dim int1 As Integer = cbxState.SelectedIndex
            '    int1 = int1 - 1
            cbxState.SelectedIndex = int1

        End If

        tbxPostal.Text = test(5)
        cbxCountry.SelectedIndex = test(6)
        Dim int2 As Integer = cbxCountry.SelectedIndex
        ' int2 = int2 - 1
        cbxCountry.SelectedIndex = int2
        tbxPhone.Text = test(7)


    End Sub
    Private Sub butUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butUpdate.Click
   
    
        Dim strSupplierId As String
        Dim strState As String
        Dim strCountry As String
        Dim strCompanyName As String
        Dim strAddress As String
        Dim strCity As String
        Dim strPostal As String
        Dim strPhone As String

        strSupplierId = lblSupplierIdOut.Text
        strState = cbxState.SelectedIndex
        strCountry = cbxCountry.SelectedIndex
        strCompanyName = tbxCompanyName.Text
        strAddress = tbxAddress.Text
        strCity = tbxCity.Text
        strPostal = tbxPostal.Text
        strPhone = tbxPhone.Text
        strCompanyName = Replace(strCompanyName, "'", "''")
        strAddress = Replace(strAddress, "'", "''")
        strCity = Replace(strCity, "'", "''")
        strPostal = Replace(strPostal, "'", "''")
        strPhone = Replace(strPhone, "'", "''")

        Dim objDataAccess As DataAccess = New DataAccess
        If strSupplierId.Length < 1 Then
            MessageBox.Show("Please Select a Record to Update!", _
                                           "Update Record", MessageBoxButtons.OK, _
                                           MessageBoxIcon.Exclamation)
 
            Exit Sub
        End If

        If tbxCompanyName.Text.Length < 1 Then

            MessageBox.Show("Please Eneter A Company Name!", _
                                        "Update Record", MessageBoxButtons.OK, _
                                        MessageBoxIcon.Exclamation)

            Exit Sub
        End If

        If tbxCity.Text.Length < 1 Then          
            MessageBox.Show("Please Eneter A City!", _
                                     "Update Record", MessageBoxButtons.OK, _
                                     MessageBoxIcon.Exclamation)
            Exit Sub
        End If





        objDataAccess.UpdateSupplier(Convert.ToInt32(strSupplierId), Convert.ToInt32(strState), Convert.ToInt32(strCountry), strCompanyName, strAddress, strCity, strPostal, strPhone)
        LoadSuppliers()

    End Sub

    Private Sub Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Delete.Click

        Dim strSupplierId As String
        Dim strState As String
        Dim strCountry As String
        Dim strCompanyName As String
        Dim strAddress As String
        Dim strCity As String
        Dim strPostal As String
        Dim strPhone As String

        strSupplierId = lblSupplierIdOut.Text
        strState = cbxState.SelectedIndex
        strCountry = cbxCountry.SelectedIndex
        strCompanyName = tbxCompanyName.Text
        strAddress = tbxAddress.Text
        strCity = tbxCity.Text
        strPostal = tbxPostal.Text
        strPhone = tbxPhone.Text

        Dim objDataAccess As DataAccess = New DataAccess

        If strSupplierId.Length < 1 Then


            MessageBox.Show("Please Select a Record to Delete!", _
                                  "Delete Record", MessageBoxButtons.OK, _
                                  MessageBoxIcon.Exclamation)
            Exit Sub
        End If
        objDataAccess.DeleteSupplier(Convert.ToInt32(strSupplierId))
        LoadSuppliers()
        clear()
    End Sub
End Class
